import { schema as defaultMarkdownSchema } from 'prosemirror-markdown'
import { Schema } from 'prosemirror-model'

export default new Schema({
  nodes: defaultMarkdownSchema.spec.nodes,
  marks: defaultMarkdownSchema.spec.marks
    .addBefore('text', 'mark', {
      toDOM: node => ['mark'],
      parseDOM: [{ tag: 'mark' }],
    })
    .addBefore('text', 'strikethrough', {
      toDOM: node => ['s'],
      parseDOM: [{ tag: 's' }],
    }),
})
