# frozen_string_literal: true

# Maneja la fecha del document
class MetadataDocumentDate < MetadataTemplate
  # La fecha por defecto es ahora!
  def default_value
    Date.today.to_time
  end

  # El valor puede ser un Date, Time o una String en el formato
  # "yyyy-mm-dd"
  def value
    return self[:value] if self[:value].is_a? Date
    return self[:value] if self[:value].is_a? Time

    begin
      self[:value] = Date.parse(self[:value]).to_time
    rescue ArgumentError, TypeError
      document.date || default_value
    end
  end
end
